<template>
  <section class="pt-1">
    <v-btn
      v-tooltip:bottom="{ text: 'Нажмите для выбора цвета', openOnClick: true }"
      prepend-icon="mdi-eyedropper-variant"
      variant="tonal"
      :style="{ 'color': modelValue }"
      rounded
    >
      <span>{{ modelValue }}</span>

      <v-menu
        activator="parent"
        transition="slide-y-transition"
        :close-on-content-click="false"
        location="top"
        z-index="99999"
      >
        <v-sheet class="mb-4">
          <v-color-picker
            :model-value="modelValue"
            hide-inputs
            show-swatches
            mode="hex"
            @update:model-value="value => $emit('update:modelValue', value)"
          />
        </v-sheet>
      </v-menu>
    </v-btn>
  </section>
</template>

<script setup lang="ts">
import { onBeforeMount, watch } from 'vue';

const props = defineProps<{ modelValue: string }>();
const emit = defineEmits(['update:modelValue']);

const DEFAULT_SELECTED_COLOR = '#134e4a';

onBeforeMount(() => {
  if (props.modelValue) return;
  emit('update:modelValue', DEFAULT_SELECTED_COLOR);
});

watch(() => props.modelValue, value => {
  if (value) return;
  emit('update:modelValue', DEFAULT_SELECTED_COLOR);
});
</script>